#include <basedef.h>
#include <vmm.h>
#include <debug.h>
#include <vwin32.h>
#include <vcomm.h>        // must be included before VXDWRAPS.H
#include <vxdwraps.h>
#include "lptacces.h"

DWORD hndPorts[3];     // LPT1, 2, 3
PFN   pfContentionHandler;

DWORD OnW32Deviceiocontrol(PDIOCPARAMETERS p);
BOOL  OnSysDynamicDeviceInit();
BOOL  OnSysDynamicDeviceExit();
DWORD Acquire( char *pszPortName );
DWORD Release( char *pszPortName );
DWORD StealNotifyHandler( void *RefData, DWORD dwNotification );

BOOL OnSysDynamicDeviceInit(void)
{
  return TRUE;
}

BOOL OnSysDynamicDeviceExit(void)
{
  return TRUE;
}

DWORD OnW32Deviceiocontrol(PDIOCPARAMETERS p)
{
    switch (p->dwIoControlCode)
    {
    case DIOC_OPEN:    
        return 0;

    case DIOC_CLOSEHANDLE:     
        return 0;

  case LPTACCESS_FUNC_ACQUIRE:
     return Acquire( (char *)p->lpvInBuffer );

  case LPTACCESS_FUNC_RELEASE:
     return Release( (char *)p->lpvInBuffer );
     
    default:
        return -1;
    }
}

DWORD Acquire( char *pszPortName )
{
  DWORD rc;
  DWORD portnum, hndPort;

  pfContentionHandler = VCOMM_Get_Contention_Handler( pszPortName );
  if (!pfContentionHandler)
     return LPTACCESS_ERR_BAD_PORT;


  hndPort = VCOMM_Map_Name_To_Resource( pszPortName );
  if (!hndPort)
     return LPTACCESS_ERR_BAD_PORT;

  rc = (*pfContentionHandler)( ACQUIRE_RESOURCE, 
                        hndPort,
                        StealNotifyHandler, 
                        hndPort, 
                        TRUE );
                        
  if (rc == 0)
     return LPTACCESS_ERR_ACQUIRE_REFUSED;
  else
  {
     hndPorts[pszPortName[3] - '1'] = hndPort;
     return LPTACCESS_ERR_NONE;
  }
}

DWORD Release( char *pszPortName )
{
  DWORD rc, hndPort;

  hndPort = hndPorts[pszPortName[3] - '1'];

  rc = (*pfContentionHandler)( RELEASE_RESOURCE, 
                        hndPort,
                        StealNotifyHandler ); 

  if (rc == 0)
     return LPTACCESS_ERR_BAD_PORT;
  else
  {
     hndPorts[pszPortName[3] - '1'] = 0;
     return LPTACCESS_ERR_NONE;
  }
}


DWORD StealNotifyHandler( void *RefData, DWORD dwNotification )
{
  // take the simple approach: 
  // refuse all requests to steal from us
  return FALSE;
}
 
